/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "ASN1_conf.h"
#include "../lbintl.h"


ASN1_SEQUENCE(ENTITY_CONF_BODY_REP_0) = {
	ASN1_SIMPLE(ENTITY_CONF_BODY_REP_0, Enabled, ASN1_INTEGER),
}ASN1_SEQUENCE_END(ENTITY_CONF_BODY_REP_0)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_REP_0)


ASN1_CHOICE(ENTITY_CONF_BODY_REP) = {
	ASN1_EXP(ENTITY_CONF_BODY_REP, d.conf0, ENTITY_CONF_BODY_REP_0, CONF_VERSION_0),
} ASN1_CHOICE_END(ENTITY_CONF_BODY_REP)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_REP)

BEGIN_MIGRATION_FUNCTION(ENTITY_CONF_BODY_REP, REP_CONF_VERSION)
END_MIGRATION_FUNCTION(ENTITY_CONF_BODY_REP)


ASN1_SEQUENCE(ENTITY_CONF_BODY_PKI_0) = {
	ASN1_SIMPLE(ENTITY_CONF_BODY_PKI_0, offline, ASN1_INTEGER),
}ASN1_SEQUENCE_END(ENTITY_CONF_BODY_PKI_0)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_PKI_0)


ASN1_CHOICE(ENTITY_CONF_BODY_PKI) = {
	ASN1_EXP(ENTITY_CONF_BODY_PKI, d.conf0, ENTITY_CONF_BODY_PKI_0, CONF_VERSION_0),
} ASN1_CHOICE_END(ENTITY_CONF_BODY_PKI)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_PKI)

ASN1_SEQUENCE(PLUG_OPTION) = {
	ASN1_SIMPLE(PLUG_OPTION, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(PLUG_OPTION, value, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(PLUG_OPTION)
IMPLEMENT_ASN1_FUNCTIONS(PLUG_OPTION)

ASN1_SEQUENCE(EXTERNAL_ENTITY_PLUG) = {
	ASN1_SIMPLE(EXTERNAL_ENTITY_PLUG, LibraryPath, ASN1_UTF8STRING),
	ASN1_SEQUENCE_OF(EXTERNAL_ENTITY_PLUG, Options, PLUG_OPTION),
}ASN1_SEQUENCE_END(EXTERNAL_ENTITY_PLUG)
IMPLEMENT_ASN1_FUNCTIONS(EXTERNAL_ENTITY_PLUG)

ASN1_SEQUENCE(ENTITY_CONF_BODY_CA_0) = {
	ASN1_SEQUENCE_OF(ENTITY_CONF_BODY_CA_0, Exts, EXTENSION_VALUE),
	ASN1_SEQUENCE_OF(ENTITY_CONF_BODY_CA_0, CrlExts, EXTENSION_VALUE),
	ASN1_SIMPLE(ENTITY_CONF_BODY_CA_0, CrlValidityDays, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_CA_0, CrlValidityHours, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_CA_0, PlugCa, EXTERNAL_ENTITY_PLUG),
}ASN1_SEQUENCE_END(ENTITY_CONF_BODY_CA_0)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_CA_0)


ASN1_CHOICE(ENTITY_CONF_BODY_CA) = {
	ASN1_EXP(ENTITY_CONF_BODY_CA, d.conf0, ENTITY_CONF_BODY_CA_0, CONF_VERSION_0),
} ASN1_CHOICE_END(ENTITY_CONF_BODY_CA)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_CA)





ASN1_SEQUENCE(PUBLICATION_METHOD) = {
	ASN1_SIMPLE(PUBLICATION_METHOD, Name, ASN1_UTF8STRING),
	ASN1_SIMPLE(PUBLICATION_METHOD, Type, ASN1_INTEGER),
	ASN1_SIMPLE(PUBLICATION_METHOD, LibraryPath, ASN1_UTF8STRING),
	ASN1_SEQUENCE_OF(PUBLICATION_METHOD, Options, PLUG_OPTION),
}ASN1_SEQUENCE_END(PUBLICATION_METHOD)
IMPLEMENT_ASN1_FUNCTIONS(PUBLICATION_METHOD)

ASN1_SEQUENCE(PUBLICATION_ENTRY) = {
	ASN1_SIMPLE(PUBLICATION_ENTRY, CaName, ASN1_UTF8STRING),
	ASN1_SEQUENCE_OF(PUBLICATION_ENTRY, Methods, PUBLICATION_METHOD),
}ASN1_SEQUENCE_END(PUBLICATION_ENTRY)
IMPLEMENT_ASN1_FUNCTIONS(PUBLICATION_ENTRY)


ASN1_SEQUENCE(ENTITY_CONF_BODY_PUB_0) = {
	ASN1_SEQUENCE_OF(ENTITY_CONF_BODY_PUB_0, Publications, PUBLICATION_ENTRY),
	ASN1_SIMPLE(ENTITY_CONF_BODY_PUB_0, OcspEnabled, ASN1_INTEGER),
	ASN1_EXP_OPT(ENTITY_CONF_BODY_PUB_0, BindAddress, ASN1_UTF8STRING, 1),
	ASN1_EXP_OPT(ENTITY_CONF_BODY_PUB_0, Port, ASN1_INTEGER, 2),
}ASN1_SEQUENCE_END(ENTITY_CONF_BODY_PUB_0)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_PUB_0)


ASN1_CHOICE(ENTITY_CONF_BODY_PUB) = {
	ASN1_EXP(ENTITY_CONF_BODY_PUB, d.conf0, ENTITY_CONF_BODY_PUB_0, CONF_VERSION_0),
} ASN1_CHOICE_END(ENTITY_CONF_BODY_PUB)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_PUB)




ASN1_SEQUENCE(ENTITY_CONF_BODY_RA_0) = {
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, Flags, ASN1_BIT_STRING),
	ASN1_SEQUENCE_OF(ENTITY_CONF_BODY_RA_0, DnSpecs, DN_SPECS),
	ASN1_SEQUENCE_OF(ENTITY_CONF_BODY_RA_0, Policies, POLICY_VALUE),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, MinKeyLen, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, MinPwdLen, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, default_validity, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_server, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_port, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_username, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_password, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_base, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_profiles_group, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_filters, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF_BODY_RA_0, ldap_attr_name, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(ENTITY_CONF_BODY_RA_0)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_RA_0)


ASN1_CHOICE(ENTITY_CONF_BODY_RA) = {
	ASN1_EXP(ENTITY_CONF_BODY_RA, d.conf0, ENTITY_CONF_BODY_RA_0, CONF_VERSION_0),
} ASN1_CHOICE_END(ENTITY_CONF_BODY_RA)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY_RA)



ASN1_CHOICE(ENTITY_CONF_BODY) = {
	ASN1_EXP(ENTITY_CONF_BODY, d.ra_conf, ENTITY_CONF_BODY_RA, ENTITY_TYPE_RA),
	ASN1_EXP(ENTITY_CONF_BODY, d.ca_conf, ENTITY_CONF_BODY_CA, ENTITY_TYPE_CA),
	ASN1_EXP(ENTITY_CONF_BODY, d.rep_conf, ENTITY_CONF_BODY_REP, ENTITY_TYPE_REPOSITORY),
	ASN1_EXP(ENTITY_CONF_BODY, d.pub_conf, ENTITY_CONF_BODY_PUB, ENTITY_TYPE_PUBLICATION),
	ASN1_EXP(ENTITY_CONF_BODY, d.conf, ASN1_OCTET_STRING, ENTITY_TYPE_KEY_STORE),
	ASN1_EXP(ENTITY_CONF_BODY, d.pki_conf, ENTITY_CONF_BODY_PKI, ENTITY_TYPE_PKI),
} ASN1_CHOICE_END(ENTITY_CONF_BODY)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_BODY)
IMPLEMENT_ASN1_CPY_FUNCTIONS(ENTITY_CONF_BODY)


ASN1_SEQUENCE(USERS_GROUP) = {
	ASN1_SIMPLE(USERS_GROUP, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(USERS_GROUP, serial, ASN1_INTEGER),
	ASN1_SEQUENCE_OF(USERS_GROUP, users_serial, ASN1_INTEGER),
}ASN1_SEQUENCE_END(USERS_GROUP)
IMPLEMENT_ASN1_FUNCTIONS(USERS_GROUP)


ASN1_SEQUENCE(PKI_ADMIN_SERIALS) = {
	ASN1_SEQUENCE_OF(PKI_ADMIN_SERIALS, admins, PKI_ADMIN_ENTRY),
}ASN1_SEQUENCE_END(PKI_ADMIN_SERIALS)
IMPLEMENT_ASN1_FUNCTIONS(PKI_ADMIN_SERIALS)
IMPLEMENT_ASN1_CPY_FUNCTIONS(PKI_ADMIN_SERIALS)


ASN1_SEQUENCE(USERS_GROUPS) = {
	ASN1_SEQUENCE_OF(USERS_GROUPS, list, USERS_GROUP),
}ASN1_SEQUENCE_END(USERS_GROUPS)
IMPLEMENT_ASN1_FUNCTIONS(USERS_GROUPS)
IMPLEMENT_ASN1_CPY_FUNCTIONS(USERS_GROUPS)


ASN1_SEQUENCE(ACL_ENTRY) = {
	ASN1_SIMPLE(ACL_ENTRY, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(ACL_ENTRY, type, ASN1_INTEGER),
	ASN1_SIMPLE(ACL_ENTRY, serial, ASN1_INTEGER),
	ASN1_SIMPLE(ACL_ENTRY, acls, ASN1_BIT_STRING),
}ASN1_SEQUENCE_END(ACL_ENTRY)
IMPLEMENT_ASN1_FUNCTIONS(ACL_ENTRY)


ASN1_SEQUENCE(X509_ACL) = {
	ASN1_SEQUENCE_OF(X509_ACL, acl_entries, ACL_ENTRY),
	ASN1_SEQUENCE_OF(X509_ACL, acl_type, ASN1_INTEGER),
	ASN1_SIMPLE(X509_ACL, AdminSerials, PKI_ADMIN_SERIALS),
}ASN1_SEQUENCE_END(X509_ACL)
IMPLEMENT_ASN1_FUNCTIONS(X509_ACL)
IMPLEMENT_ASN1_CPY_FUNCTIONS(X509_ACL)


ASN1_SEQUENCE(REP_ENTRY_INFO) = {
	ASN1_SIMPLE(REP_ENTRY_INFO, RepositorySSL, X509),
	ASN1_SIMPLE(REP_ENTRY_INFO, Name, ASN1_UTF8STRING),
	ASN1_SIMPLE(REP_ENTRY_INFO, Address, ASN1_UTF8STRING),
	ASN1_SIMPLE(REP_ENTRY_INFO, Port, ASN1_INTEGER),
	ASN1_SIMPLE(REP_ENTRY_INFO, Flags, ASN1_BIT_STRING),
}ASN1_SEQUENCE_END(REP_ENTRY_INFO)
IMPLEMENT_ASN1_FUNCTIONS(REP_ENTRY_INFO)
IMPLEMENT_ASN1_CPY_FUNCTIONS(REP_ENTRY_INFO)


ASN1_SEQUENCE(REPS_INFO) = {
	ASN1_SEQUENCE_OF(REPS_INFO, list, REP_ENTRY_INFO),
}ASN1_SEQUENCE_END(REPS_INFO)
IMPLEMENT_ASN1_FUNCTIONS(REPS_INFO)
IMPLEMENT_ASN1_CPY_FUNCTIONS(REPS_INFO)


ASN1_SEQUENCE(CA_ENTRY_INFO) = {
	ASN1_SIMPLE(CA_ENTRY_INFO, CaSSL, X509),
	ASN1_SIMPLE(CA_ENTRY_INFO, Name, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(CA_ENTRY_INFO)
IMPLEMENT_ASN1_FUNCTIONS(CA_ENTRY_INFO)


ASN1_SEQUENCE(CAS_INFO) = {
	ASN1_SEQUENCE_OF(CAS_INFO, list, CA_ENTRY_INFO),
}ASN1_SEQUENCE_END(CAS_INFO)
IMPLEMENT_ASN1_FUNCTIONS(CAS_INFO)


ASN1_SEQUENCE(RA_ENTRY_INFO) = {
	ASN1_SIMPLE(RA_ENTRY_INFO, RaSSL, X509),
	ASN1_SIMPLE(RA_ENTRY_INFO, Name, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(RA_ENTRY_INFO)
IMPLEMENT_ASN1_FUNCTIONS(RA_ENTRY_INFO)


ASN1_SEQUENCE(RAS_INFO) = {
	ASN1_SEQUENCE_OF(RAS_INFO, list, RA_ENTRY_INFO),
}ASN1_SEQUENCE_END(RAS_INFO)
IMPLEMENT_ASN1_FUNCTIONS(RAS_INFO)



ASN1_SEQUENCE(KEY_ENTRY_INFO) = {
	ASN1_SIMPLE(KEY_ENTRY_INFO, KeySSL, X509),
	ASN1_SIMPLE(KEY_ENTRY_INFO, Name, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(KEY_ENTRY_INFO)
IMPLEMENT_ASN1_FUNCTIONS(KEY_ENTRY_INFO)


ASN1_SEQUENCE(KEYS_INFO) = {
	ASN1_SEQUENCE_OF(KEYS_INFO, list, KEY_ENTRY_INFO),
}ASN1_SEQUENCE_END(KEYS_INFO)
IMPLEMENT_ASN1_FUNCTIONS(KEYS_INFO)



ASN1_SEQUENCE(PUB_ENTRY_INFO) = {
	ASN1_SIMPLE(PUB_ENTRY_INFO, PubSSL, X509),
	ASN1_SIMPLE(PUB_ENTRY_INFO, PubOCSP, X509),
	ASN1_SIMPLE(PUB_ENTRY_INFO, Name, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(PUB_ENTRY_INFO)
IMPLEMENT_ASN1_FUNCTIONS(PUB_ENTRY_INFO)
IMPLEMENT_ASN1_CPY_FUNCTIONS(PUB_ENTRY_INFO)


ASN1_SEQUENCE(PUBS_INFO) = {
	ASN1_SEQUENCE_OF(PUBS_INFO, list, PUB_ENTRY_INFO),
}ASN1_SEQUENCE_END(PUBS_INFO)
IMPLEMENT_ASN1_FUNCTIONS(PUBS_INFO)



ASN1_SEQUENCE_ref(INTERNAL_PKI_CRL, NULL, CRYPTO_LOCK_INTERNAL_PKI_CRL) = {
	ASN1_SIMPLE(INTERNAL_PKI_CRL, RootCaCrl, X509_CRL),
	ASN1_SIMPLE(INTERNAL_PKI_CRL, UsersCaCrl, X509_CRL),
	ASN1_SIMPLE(INTERNAL_PKI_CRL, EntitiesCaCrl, X509_CRL),
	ASN1_SIMPLE(INTERNAL_PKI_CRL, OcspCaCrl, X509_CRL),
}ASN1_SEQUENCE_END_ref(INTERNAL_PKI_CRL, INTERNAL_PKI_CRL)
IMPLEMENT_ASN1_FUNCTIONS(INTERNAL_PKI_CRL)
IMPLEMENT_ASN1_CPY_FUNCTIONS_REF(INTERNAL_PKI_CRL, CRYPTO_LOCK_INTERNAL_PKI_CRL)

	
ASN1_SEQUENCE_ref(INTERNAL_PKI_CA, NULL, CRYPTO_LOCK_INTERNAL_PKI_CA) = {
	ASN1_SIMPLE(INTERNAL_PKI_CA, RootCa, X509),
	ASN1_SIMPLE(INTERNAL_PKI_CA, UsersCa, X509),
	ASN1_SIMPLE(INTERNAL_PKI_CA, EntitiesCa, X509),
	ASN1_SIMPLE(INTERNAL_PKI_CA, OcspCa, X509),
	ASN1_SIMPLE(INTERNAL_PKI_CA, PkiCert, X509),
}ASN1_SEQUENCE_END_ref(INTERNAL_PKI_CA, INTERNAL_PKI_CA)
IMPLEMENT_ASN1_FUNCTIONS(INTERNAL_PKI_CA)
IMPLEMENT_ASN1_CPY_FUNCTIONS_REF(INTERNAL_PKI_CA, CRYPTO_LOCK_INTERNAL_PKI_CA)
	

ASN1_SEQUENCE(ENTITY_AUDIT_ENTRY) = {
	ASN1_EXP_OPT(ENTITY_AUDIT_ENTRY, object, ASN1_UTF8STRING, 1),
	ASN1_EXP_OPT(ENTITY_AUDIT_ENTRY, type, ASN1_INTEGER, 2),
	ASN1_EXP_OPT(ENTITY_AUDIT_ENTRY, status, ASN1_INTEGER, 3),
	ASN1_EXP_OPT(ENTITY_AUDIT_ENTRY, user, ASN1_UTF8STRING, 4),
}ASN1_SEQUENCE_END(ENTITY_AUDIT_ENTRY)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_AUDIT_ENTRY)
IMPLEMENT_ASN1_CPY_FUNCTIONS(ENTITY_AUDIT_ENTRY)

ASN1_SEQUENCE(ENTITY_AUDIT) = {
	ASN1_SEQUENCE_OF(ENTITY_AUDIT, audits, ENTITY_AUDIT_ENTRY),
}ASN1_SEQUENCE_END(ENTITY_AUDIT)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_AUDIT)
IMPLEMENT_ASN1_CPY_FUNCTIONS(ENTITY_AUDIT)


ASN1_SEQUENCE(EXTENSION_VALUE) = {
	ASN1_SIMPLE(EXTENSION_VALUE, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(EXTENSION_VALUE, value, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(EXTENSION_VALUE)
IMPLEMENT_ASN1_FUNCTIONS(EXTENSION_VALUE)


ASN1_SEQUENCE(POLICY_VALUE) = {
	ASN1_SIMPLE(POLICY_VALUE, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(POLICY_VALUE, value, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(POLICY_VALUE)
IMPLEMENT_ASN1_FUNCTIONS(POLICY_VALUE)
IMPLEMENT_ASN1_CPY_FUNCTIONS(POLICY_VALUE)


ASN1_SEQUENCE(DN_SPECS) = {
	ASN1_SIMPLE(DN_SPECS, Name, ASN1_UTF8STRING),
	ASN1_SIMPLE(DN_SPECS, Default, ASN1_UTF8STRING),
	ASN1_SIMPLE(DN_SPECS, Comment, ASN1_UTF8STRING),
	ASN1_SIMPLE(DN_SPECS, Min, ASN1_INTEGER),
	ASN1_SIMPLE(DN_SPECS, Max, ASN1_INTEGER),
}ASN1_SEQUENCE_END(DN_SPECS)
IMPLEMENT_ASN1_FUNCTIONS(DN_SPECS)
IMPLEMENT_ASN1_STACK_CPY_FUNCTIONS(DN_SPECS)
IMPLEMENT_ASN1_CPY_FUNCTIONS(DN_SPECS)


ASN1_SEQUENCE(EMAIL_CONF) = {
	ASN1_SIMPLE(EMAIL_CONF, server, ASN1_UTF8STRING),
	ASN1_SIMPLE(EMAIL_CONF, port, ASN1_INTEGER),
}ASN1_SEQUENCE_END(EMAIL_CONF)
IMPLEMENT_ASN1_FUNCTIONS(EMAIL_CONF)
IMPLEMENT_ASN1_CPY_FUNCTIONS(EMAIL_CONF)

ASN1_SEQUENCE(ENTITY_CONF) = {
	ASN1_SIMPLE(ENTITY_CONF, Name, ASN1_UTF8STRING),
	ASN1_SIMPLE(ENTITY_CONF, version, ASN1_INTEGER),
	ASN1_SIMPLE(ENTITY_CONF, acls, X509_ACL),
	ASN1_SIMPLE(ENTITY_CONF, body, ENTITY_CONF_BODY),
	ASN1_SIMPLE(ENTITY_CONF, Repositories, REPS_INFO),
	ASN1_SIMPLE(ENTITY_CONF, Ras, RAS_INFO),
	ASN1_SIMPLE(ENTITY_CONF, Cas, CAS_INFO),
	ASN1_SIMPLE(ENTITY_CONF, KeyStores, KEYS_INFO),
	ASN1_SIMPLE(ENTITY_CONF, Publications, PUBS_INFO),
	ASN1_SIMPLE(ENTITY_CONF, crls, INTERNAL_PKI_CRL),
	ASN1_SIMPLE(ENTITY_CONF, mail_conf, EMAIL_CONF),
	ASN1_SIMPLE(ENTITY_CONF, audits, ENTITY_AUDIT),
	ASN1_SIMPLE(ENTITY_CONF, groups, USERS_GROUPS),
}ASN1_SEQUENCE_END(ENTITY_CONF)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF)
IMPLEMENT_ASN1_ENCRYPT_SIGN(ENTITY_CONF)
IMPLEMENT_ASN1_CPY_FUNCTIONS(ENTITY_CONF)


ASN1_SEQUENCE(PKI_ADMIN_ENTRY) = {
	ASN1_SIMPLE(PKI_ADMIN_ENTRY, serial, ASN1_INTEGER),
	ASN1_SIMPLE(PKI_ADMIN_ENTRY, email, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(PKI_ADMIN_ENTRY)
IMPLEMENT_ASN1_FUNCTIONS(PKI_ADMIN_ENTRY)



ASN1_SEQUENCE_ref(ENTITY_CONF_CRYPTED, NULL, CRYPTO_LOCK_ENTITY_CONF_CRYPTED) = {
	ASN1_SIMPLE(ENTITY_CONF_CRYPTED, recipient, X509_PUBKEY),
	ASN1_SIMPLE(ENTITY_CONF_CRYPTED, crypted, ASN1_ENCRYPT_SIGN),
}ASN1_SEQUENCE_END_ref(ENTITY_CONF_CRYPTED, ENTITY_CONF_CRYPTED)
IMPLEMENT_ASN1_FUNCTIONS(ENTITY_CONF_CRYPTED)
IMPLEMENT_ASN1_CPY_FUNCTIONS_REF(ENTITY_CONF_CRYPTED, CRYPTO_LOCK_ENTITY_CONF_CRYPTED)
IMPLEMENT_PEM_CONVERT(ENTITY_CONF_CRYPTED, "NEWPKI CRYPTED ENTITY CONF")

ASN1_SEQUENCE(EXPORTED_PKI_CONF_BODY) = {
	ASN1_SIMPLE(EXPORTED_PKI_CONF_BODY, version, ASN1_INTEGER),
	ASN1_SEQUENCE_OF(EXPORTED_PKI_CONF_BODY, all_confs, ENTITY_CONF_CRYPTED),
}ASN1_SEQUENCE_END(EXPORTED_PKI_CONF_BODY)
IMPLEMENT_ASN1_FUNCTIONS(EXPORTED_PKI_CONF_BODY)


ASN1_SEQUENCE(EXPORTED_PKI_CONF) = {
	ASN1_SIMPLE(EXPORTED_PKI_CONF, confs, EXPORTED_PKI_CONF_BODY),
	ASN1_SIMPLE(EXPORTED_PKI_CONF, sig, X509_SIG),
}ASN1_SEQUENCE_END(EXPORTED_PKI_CONF)
IMPLEMENT_ASN1_FUNCTIONS(EXPORTED_PKI_CONF)
IMPLEMENT_PEM_CONVERT(EXPORTED_PKI_CONF, "NEWPKI PKI CONF")
IMPLEMENT_ASN1_CPY_FUNCTIONS(EXPORTED_PKI_CONF)

typedef struct md_ACL_MESSAGE_ENTRY
{
	ACL_TYPE uID;
	char * Text;
}ACL_MESSAGE_ENTRY;


ACL_MESSAGE_ENTRY AclMessagesStatus[]={
	{ ACL_TYPE_AUTHENTICATE_ON_ENTITY,			_lb("Authenticate on entity") }, 
	{ ACL_TYPE_MANAGE_USERS,					_lb("Manage users") }, 
	{ ACL_TYPE_MANAGE_ENTITIES,					_lb("Manage entities") }, 
	{ ACL_TYPE_VIEW_LOGS,						_lb("View logs") }, 
	{ ACL_TYPE_MANAGE_ACLS,						_lb("Manage ACLs") }, 
	{ ACL_TYPE_MODIFY_PKI_STATUS,				_lb("Modify the PKI status") }, 
	{ ACL_TYPE_IMPORT_CONF,						_lb("Import PKI configuration") },
	{ ACL_TYPE_SEND_ADMIN_MAIL,					_lb("Send an administrative mail") },
	{ ACL_TYPE_CREATE_ROOT_CA,					_lb("Create a ROOT CA") },
	{ ACL_TYPE_CREATE_CHILD_CA,					_lb("Create a Child CA") },
	{ ACL_TYPE_CA_SIGN_CERT,					_lb("Sign a certificate") },
	{ ACL_TYPE_CA_REVOKE_CERT,					_lb("Revoke a certificate") },
	{ ACL_TYPE_CA_GENERATE_CRL,					_lb("Generate CRL") },
	{ ACL_TYPE_IMPORT_NEWPKI_OBJECTS,			_lb("Import NewPKI objects") },
	{ ACL_TYPE_RA_IMPORT_PROFILE,				_lb("Import a profile") },
	{ ACL_TYPE_RA_DELEGATE_PROFILE_OWNERSHIP,	_lb("Delegate profile ownership") },
	{ ACL_TYPE_MANAGE_USERS,		NULL }
};





char * GetACL_String(ACL_TYPE Type)
{
	for(int i=0; AclMessagesStatus[i].Text; i++)
	{
		if(AclMessagesStatus[i].uID == Type) return AclMessagesStatus[i].Text;
	}

	return _lb("Unknown");
}



