/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "ASN1_resp.h"



ASN1_CHOICE(ADMIN_RESPONSE_BODY) = {
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.errors, ERROR_ENTRY, ADMIN_RESP_TYPE_ERRORS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.other, ASN1_NULL, ADMIN_RESP_TYPE_NONE),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.usertype, ASN1_INTEGER, ADMIN_RESP_TYPE_USER_TYPE),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.users, USER_ENTRY, ADMIN_RESP_TYPE_ENUM_USERS),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.entities, ENTITY_ENTRY_INFO, ADMIN_RESP_TYPE_ENUM_ENTITIES),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.logs, LOG_ENTRY, ADMIN_RESP_TYPE_ENUM_LOGS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.cre_entity, ENTITY_CREATION_RESP, ADMIN_RESP_TYPE_CREATE_ENTITY),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.sign_entity, ENTITY_SIGNATURE_RESP, ADMIN_RESP_TYPE_SIGN_ENTITY),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.users_cert, USER_ENTRY_CERT, ADMIN_RESP_TYPE_ENUM_USERS_CERT),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.create_pki_user, X509, ADMIN_RESP_TYPE_CREATE_PKI_USER),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.status, ASN1_INTEGER, ADMIN_RESP_TYPE_STATUS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.acls_conf, X509_ACL, ADMIN_RESP_TYPE_ACLS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.my_acl, ASN1_BIT_STRING, ADMIN_RESP_TYPE_MY_ACL),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.conf, EXPORTED_PKI_CONF, ADMIN_RESP_TYPE_CONF),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.my_conf, ENTITY_CONF_CRYPTED, ADMIN_RESP_TYPE_MY_CONF),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.repositories, REPS_INFO, ADMIN_RESP_TYPE_GET_REPOSITORIES),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.logs_type, ASN1_INTEGER, ADMIN_RESP_TYPE_LOGS_TYPE),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.entity_conf, ENTITY_CONF_BODY, ADMIN_RESP_TYPE_ENTITY_CONF),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.acls_conf, X509_ACL, ADMIN_RESP_TYPE_ENTITY_ACL),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.mail_conf, EMAIL_CONF, ADMIN_RESP_TYPE_MAIL_CONF),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.audits, ENTITY_AUDIT, ADMIN_RESP_TYPE_AUDITS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.entities_links, ENTITIES_LINKS, ADMIN_RESP_TYPE_ENTITIES_LINKS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.object_reqs, STORED_NEWPKI_REQUESTS, ADMIN_RESP_TYPE_REQS),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.certs, INTERNAL_CA_CERT, ADMIN_RESP_TYPE_CERTS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.p7b, PKCS7, ADMIN_RESP_TYPE_P7B),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.csr, X509_REQ, ADMIN_RESP_TYPE_CSR),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.crls, X509_CRL, ADMIN_RESP_TYPE_CRLS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.groups, USERS_GROUPS, ADMIN_RESP_TYPE_GROUPS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.id, ASN1_INTEGER, ADMIN_RESP_TYPE_PROFILE_ID),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.transactionID, ASN1_OCTET_STRING, ADMIN_RESP_TYPE_TRANSACTION_ID),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.object_resps, STORED_NEWPKI_RESPONSES, ADMIN_RESP_TYPE_RESPS),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.profiles, NEWPKI_PROFILE_DATAS, ADMIN_RESP_TYPE_PROFILES),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.local_entity_conf, ENTITY_CONF, ADMIN_RESP_TYPE_LOCAL_ENTITY_CONF),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.known_objects, OBJECTS_LIST_RESPONSE, ADMIN_RESP_TYPE_KNOWN_OBJECTS),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.id, ASN1_INTEGER, ADMIN_RESP_TYPE_REQ_ID),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.cert, X509, ADMIN_RESP_TYPE_CERT),
	ASN1_EXP(ADMIN_RESPONSE_BODY, d.status, ASN1_INTEGER, ADMIN_RESP_TYPE_LOGS_COUNT),
	ASN1_EXP_SEQUENCE_OF(ADMIN_RESPONSE_BODY, d.ldap_results, LDAP_RESULT, ADMIN_RESP_TYPE_LDAP_RESULTS),
} ASN1_CHOICE_END(ADMIN_RESPONSE_BODY)
IMPLEMENT_ASN1_FUNCTIONS(ADMIN_RESPONSE_BODY)


ASN1_SEQUENCE(ADMIN_RESPONSE) = {
	ASN1_SIMPLE(ADMIN_RESPONSE, body, ADMIN_RESPONSE_BODY),
	ASN1_SIMPLE(ADMIN_RESPONSE, signing_cert, X509),
	ASN1_SIMPLE(ADMIN_RESPONSE, sig_algo, X509_ALGOR),
	ASN1_SIMPLE(ADMIN_RESPONSE, signature, ASN1_BIT_STRING),
}ASN1_SEQUENCE_END(ADMIN_RESPONSE)
IMPLEMENT_ASN1_FUNCTIONS(ADMIN_RESPONSE)


ASN1_SEQUENCE(INTERNAL_CA_CERT) = {
	ASN1_SIMPLE(INTERNAL_CA_CERT, ca_type, ASN1_INTEGER),
	ASN1_SIMPLE(INTERNAL_CA_CERT, serial, ASN1_INTEGER),
	ASN1_SIMPLE(INTERNAL_CA_CERT, state, ASN1_INTEGER),
	ASN1_SIMPLE(INTERNAL_CA_CERT, dn, ASN1_UTF8STRING),
	ASN1_SIMPLE(INTERNAL_CA_CERT, begin_date, ASN1_INTEGER),
	ASN1_SIMPLE(INTERNAL_CA_CERT, end_date, ASN1_INTEGER),
	ASN1_EXP_OPT(INTERNAL_CA_CERT, rev_date, ASN1_INTEGER, 0),
	ASN1_EXP(INTERNAL_CA_CERT, cert, X509, 1),
}ASN1_SEQUENCE_END(INTERNAL_CA_CERT)
IMPLEMENT_ASN1_FUNCTIONS(INTERNAL_CA_CERT)


ASN1_SEQUENCE(LDAP_OBJECT) = {
	ASN1_SIMPLE(LDAP_OBJECT, name, ASN1_UTF8STRING),
	ASN1_SIMPLE(LDAP_OBJECT, value, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(LDAP_OBJECT)
IMPLEMENT_ASN1_FUNCTIONS(LDAP_OBJECT)



ASN1_SEQUENCE(LDAP_RESULT) = {
	ASN1_SIMPLE(LDAP_RESULT, rdn, ASN1_UTF8STRING),
	ASN1_SIMPLE(LDAP_RESULT, uid, ASN1_UTF8STRING),
	ASN1_SEQUENCE_OF(LDAP_RESULT, objects, LDAP_OBJECT),
}ASN1_SEQUENCE_END(LDAP_RESULT)
IMPLEMENT_ASN1_FUNCTIONS(LDAP_RESULT)


