/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/

#include "ASN1_user.h"


ASN1_SEQUENCE(USER_INFO) = {
	ASN1_SIMPLE(USER_INFO, Name, ASN1_UTF8STRING),
	ASN1_SIMPLE(USER_INFO, Activated, ASN1_INTEGER),
	ASN1_SIMPLE(USER_INFO, Flags, ASN1_INTEGER),
}ASN1_SEQUENCE_END(USER_INFO)
IMPLEMENT_ASN1_FUNCTIONS(USER_INFO)


ASN1_SEQUENCE(USER_ENTRY_CERT) = {
	ASN1_SIMPLE(USER_ENTRY_CERT, user_cert, X509),
}ASN1_SEQUENCE_END(USER_ENTRY_CERT)
IMPLEMENT_ASN1_FUNCTIONS(USER_ENTRY_CERT)


ASN1_SEQUENCE(USER_ENTRY) = {
	ASN1_SIMPLE(USER_ENTRY, user_id, ASN1_INTEGER),
	ASN1_SIMPLE(USER_ENTRY, user_info, USER_INFO),
}ASN1_SEQUENCE_END(USER_ENTRY)
IMPLEMENT_ASN1_FUNCTIONS(USER_ENTRY)

ASN1_SEQUENCE(CHANGE_USER_PASSWD) = {
	ASN1_SIMPLE(CHANGE_USER_PASSWD, user_id, ASN1_INTEGER),
	ASN1_SIMPLE(CHANGE_USER_PASSWD, Password, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(CHANGE_USER_PASSWD)
IMPLEMENT_ASN1_FUNCTIONS(CHANGE_USER_PASSWD)

ASN1_SEQUENCE(CHANGE_PASSWD) = {
	ASN1_SIMPLE(CHANGE_PASSWD, Password, ASN1_UTF8STRING),
}ASN1_SEQUENCE_END(CHANGE_PASSWD)
IMPLEMENT_ASN1_FUNCTIONS(CHANGE_PASSWD)


