/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/



#ifndef ENTITY_CA_ASN1_H
#define ENTITY_CA_ASN1_H

#include <ASN1/ASN1_entity.h>
#include <ASN1/ASN1_cert.h>
#include "CA_Handler.h"



typedef struct st_LOCAL_CA_CONF
{
	ENTITY_CONF_CRYPTED * conf;
	INTERNAL_PKI_CA * cas;
	INTERNAL_CA_KEY * privkey;	//When generating the real CA certificate 
								//we need to store temporaly the key, 
								//once the parent CA has generated our 
								//certificate we will call CA_Handler:Create, 
								//with the cert end this key
	STACK_OF(X509) * parentCerts;
}LOCAL_CA_CONF;
DECLARE_ASN1_FUNCTIONS(LOCAL_CA_CONF)
DECLARE_ASN1_ENCRYPT_SIGN(LOCAL_CA_CONF)




#endif
