/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/



#include "Entity_PKI_ASN1.h"

ASN1_SEQUENCE(STORED_ENTITY_CONF) = {
	ASN1_SIMPLE(STORED_ENTITY_CONF, conf, ENTITY_CONF),
	ASN1_SIMPLE(STORED_ENTITY_CONF, certificate, X509),
}ASN1_SEQUENCE_END(STORED_ENTITY_CONF)
IMPLEMENT_ASN1_FUNCTIONS(STORED_ENTITY_CONF)


ASN1_SEQUENCE(PKI_CONF) = {
	ASN1_SEQUENCE_OF(PKI_CONF, confs, STORED_ENTITY_CONF),
	ASN1_SIMPLE(PKI_CONF, crypt_confs, EXPORTED_PKI_CONF),
	ASN1_SIMPLE(PKI_CONF, Repositories, REPS_INFO),
	ASN1_SIMPLE(PKI_CONF, cas, INTERNAL_PKI_CA),
	ASN1_SIMPLE(PKI_CONF, Publications, PUBS_INFO),
	ASN1_SIMPLE(PKI_CONF, my_conf, ENTITY_CONF),
	ASN1_SIMPLE(PKI_CONF, links, ENTITIES_LINKS),
}ASN1_SEQUENCE_END(PKI_CONF)
IMPLEMENT_ASN1_FUNCTIONS(PKI_CONF)
IMPLEMENT_ASN1_ENCRYPT_SIGN(PKI_CONF)




STORED_ENTITY_CONF * STORED_ENTITY_CONF_get(STACK_OF(STORED_ENTITY_CONF) * entities, X509 * cert)
{
	STORED_ENTITY_CONF * conf = NULL;
	int i;	

	for(i=0; i < SKM_sk_num(STORED_ENTITY_CONF, entities); i++)
	{
		conf = SKM_sk_value(STORED_ENTITY_CONF, entities, i);
		if(!conf) continue;
		if(X509_cmp(conf->certificate, cert) == 0)
		{
			return conf;
		}
	}

	return NULL;
}

