/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/



#ifndef ENTITY_PKI_ASN1_H
#define ENTITY_PKI_ASN1_H

#include <ASN1/ASN1_conf.h>
#include "CA_Handler.h"

typedef struct st_STORED_ENTITY_CONF
{
	ENTITY_CONF * conf;
	X509 * certificate;
}STORED_ENTITY_CONF;
DECLARE_ASN1_FUNCTIONS(STORED_ENTITY_CONF)


typedef struct st_PKI_CONF
{
	STACK_OF(STORED_ENTITY_CONF) * confs;				//The confs in "clear text" format
	EXPORTED_PKI_CONF * crypt_confs;					//The same as confs but crypted for the entities
	REPS_INFO * Repositories;					//The repositories list
	PUBS_INFO * Publications;							//The Publications list
	INTERNAL_PKI_CA * cas;								//The internal CAs certs
	ENTITY_CONF * my_conf;
	ENTITIES_LINKS * links;
}PKI_CONF;
DECLARE_ASN1_FUNCTIONS(PKI_CONF)
DECLARE_ASN1_ENCRYPT_SIGN(PKI_CONF)

STORED_ENTITY_CONF * STORED_ENTITY_CONF_get(STACK_OF(STORED_ENTITY_CONF) * entities, X509 * cert);

#endif
