// MailInfo.cpp: implementation of the MailInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "MailInfo.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MailInfo::MailInfo()
{
	m_SignMail = false;
}

MailInfo::~MailInfo()
{
}

void MailInfo::set_MailTo(const mString & MailTo)
{
	m_MailTo = MailTo;
}

const mString & MailInfo::get_MailTo() const
{
	return m_MailTo;
}

void MailInfo::set_AttachName(const mString & AttachName)
{
	m_AttachName = AttachName;
}

const mString & MailInfo::get_AttachName() const
{
	return m_AttachName;
}

void MailInfo::set_SignMail(bool SignMail)
{
	m_SignMail = SignMail;
}

bool MailInfo::get_SignMail() const
{
	return m_SignMail;
}

void MailInfo::set_Body(const mString & Body)
{
	m_Body = Body;
}

const mString & MailInfo::get_Body() const
{
	return m_Body;
}

void MailInfo::set_Subject(const mString & Subject)
{
	m_Subject = Subject;
}

const mString & MailInfo::get_Subject() const
{
	return m_Subject;
}

void MailInfo::set_AttachType(const mString & AttachType)
{
	m_AttachType = AttachType;
}

const mString & MailInfo::get_AttachType() const
{
	return m_AttachType;
}

const mBuffer & MailInfo::c_get_Attach() const
{
	return m_Attach;
}

mBuffer & MailInfo::get_Attach()
{
	return m_Attach;
}

MailInfo::operator int() const
{
	if(!m_Subject.size() || !m_Body.size())
		return 0;
	else
		return 1;
}

bool MailInfo::FromMAIL_INFO(const MAIL_INFO *mail)
{
	Clear();
	m_Body = ASN1_STRING_GET(mail->Body);
	m_Subject = ASN1_STRING_GET(mail->Subject);
	m_SignMail = (ASN1_INTEGER_GET(mail->SignMail) == 1);
	m_AttachName = ASN1_STRING_GET(mail->AttachName);
	m_AttachType = ASN1_STRING_GET(mail->AttachType);

	if(mail->Attach->data && mail->Attach->length)
	{
		if(!m_Attach.Copy(mail->Attach->data, mail->Attach->length))
		{
			NEWPKIerr(PKI_ERROR_TXT, ERROR_ABORT);
			return false;
		}
	}

	return true;
}

void MailInfo::Clear()
{
	m_Attach.Clear();
	m_AttachName = "";
	m_AttachType = "";
	m_MailTo = "";
	m_Body = "";
	m_Subject = "";
	m_SignMail = false;
}
