/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/

// PKIX_Central.h: interface for the PKIX_Central class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PKIX_CENTRAL_H
#define PKIX_CENTRAL_H

class OcspServers;

#include <NewPKI.h>
#include <ASN1/ASN1_resp.h>
#include <Conf.h>

#include <openssl/engine.h>

#include <SQL/SQL_Conn.h>
#include <SQL/SQL.h>
#include <SQL/SQL_CMD.h>

#include "Entity.h"
#include "SOCK_SERVER.h"
#include "Entity_SERVER.h"
#include <ASN1/ASN1_resp.h>
#include <openssl/ocsp.h>


class PKIX_Central  
{
public:
	void SetOcspServersHandler(OcspServers * OcspServersHandler);
	PKIX_Central(const Config & Conf);
	virtual ~PKIX_Central();
	void OnADMIN_REQUEST(ADMIN_RESPONSE_BODY * response, const char * ClientIp, const PKI_CERT & ClientCert, ADMIN_REQUEST * request);
	bool OnNewOCSP(const char * Ip, OCSP_REQUEST * request, OCSP_RESPONSE ** response, const mString & EntityName, bool & ShouldStopServer);
	bool SignResponse(ADMIN_RESPONSE* response);
	void SpawnStop();
	void OnConnectionClosed();
	void GetSSL_Cert(PKI_CERT & SslCert);

private:
	void Clear();
	Config m_Conf;
	ENGINE * m_Engine;
	Entity_SERVER * LocalServer;
	AuthModule * m_AuthModule;
	bool LoadEngine(const mString & engine, const mString & EngineCmd);
};

#endif
